<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ZooKeeper.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper</a> &gt; <span class="el_source">ZooKeeper.java</span></div><h1>ZooKeeper.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper;

import org.apache.zookeeper.AsyncCallback.*;
import org.apache.zookeeper.OpResult.ErrorResult;
import org.apache.zookeeper.client.ConnectStringParser;
import org.apache.zookeeper.client.HostProvider;
import org.apache.zookeeper.client.StaticHostProvider;
import org.apache.zookeeper.client.ZooKeeperSaslClient;
import org.apache.zookeeper.common.PathUtils;
import org.apache.zookeeper.data.ACL;
import org.apache.zookeeper.data.Stat;
import org.apache.zookeeper.proto.*;
import org.apache.zookeeper.server.DataTree;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.IOException;
import java.net.SocketAddress;
import java.util.*;

/**
 * This is the main class of ZooKeeper client library. To use a ZooKeeper
 * service, an application must first instantiate an object of ZooKeeper class.
 * All the iterations will be done by calling the methods of ZooKeeper class.
 * The methods of this class are thread-safe unless otherwise noted.
 * &lt;p&gt;
 * Once a connection to a server is established, a session ID is assigned to the
 * client. The client will send heart beats to the server periodically to keep
 * the session valid.
 * &lt;p&gt;
 * The application can call ZooKeeper APIs through a client as long as the
 * session ID of the client remains valid.
 * &lt;p&gt;
 * If for some reason, the client fails to send heart beats to the server for a
 * prolonged period of time (exceeding the sessionTimeout value, for instance),
 * the server will expire the session, and the session ID will become invalid.
 * The client object will no longer be usable. To make ZooKeeper API calls, the
 * application must create a new client object.
 * &lt;p&gt;
 * If the ZooKeeper server the client currently connects to fails or otherwise
 * does not respond, the client will automatically try to connect to another
 * server before its session ID expires. If successful, the application can
 * continue to use the client.
 * &lt;p&gt;
 * The ZooKeeper API methods are either synchronous or asynchronous. Synchronous
 * methods blocks until the server has responded. Asynchronous methods just queue
 * the request for sending and return immediately. They take a callback object that
 * will be executed either on successful execution of the request or on error with
 * an appropriate return code (rc) indicating the error.
 * &lt;p&gt;
 * Some successful ZooKeeper API calls can leave watches on the &quot;data nodes&quot; in
 * the ZooKeeper server. Other successful ZooKeeper API calls can trigger those
 * watches. Once a watch is triggered, an event will be delivered to the client
 * which left the watch at the first place. Each watch can be triggered only
 * once. Thus, up to one event will be delivered to a client for every watch it
 * leaves.
 * &lt;p&gt;
 * A client needs an object of a class implementing Watcher interface for
 * processing the events delivered to the client.
 *
 * When a client drops current connection and re-connects to a server, all the
 * existing watches are considered as being triggered but the undelivered events
 * are lost. To emulate this, the client will generate a special event to tell
 * the event handler a connection has been dropped. This special event has type
 * EventNone and state sKeeperStateDisconnected.
 *
 */
public class ZooKeeper {

    public static final String ZOOKEEPER_CLIENT_CNXN_SOCKET = &quot;zookeeper.clientCnxnSocket&quot;;

    protected final ClientCnxn cnxn;
    private static final Logger LOG;
    static {
        //Keep these two lines together to keep the initialization order explicit
<span class="fc" id="L94">        LOG = LoggerFactory.getLogger(ZooKeeper.class);</span>
<span class="fc" id="L95">        Environment.logEnv(&quot;Client environment:&quot;, LOG);</span>
<span class="fc" id="L96">    }</span>

    public ZooKeeperSaslClient getSaslClient() {
<span class="fc" id="L99">        return cnxn.zooKeeperSaslClient;</span>
    }

<span class="fc" id="L102">    private final ZKWatchManager watchManager = new ZKWatchManager();</span>

    List&lt;String&gt; getDataWatches() {
<span class="fc" id="L105">        synchronized(watchManager.dataWatches) {</span>
<span class="fc" id="L106">            List&lt;String&gt; rc = new ArrayList&lt;String&gt;(watchManager.dataWatches.keySet());</span>
<span class="fc" id="L107">            return rc;</span>
<span class="nc" id="L108">        }</span>
    }
    List&lt;String&gt; getExistWatches() {
<span class="fc" id="L111">        synchronized(watchManager.existWatches) {</span>
<span class="fc" id="L112">            List&lt;String&gt; rc =  new ArrayList&lt;String&gt;(watchManager.existWatches.keySet());</span>
<span class="fc" id="L113">            return rc;</span>
<span class="nc" id="L114">        }</span>
    }
    List&lt;String&gt; getChildWatches() {
<span class="fc" id="L117">        synchronized(watchManager.childWatches) {</span>
<span class="fc" id="L118">            List&lt;String&gt; rc = new ArrayList&lt;String&gt;(watchManager.childWatches.keySet());</span>
<span class="fc" id="L119">            return rc;</span>
<span class="nc" id="L120">        }</span>
    }

    /**
     * Manage watchers &amp; handle events generated by the ClientCnxn object.
     *
     * We are implementing this as a nested class of ZooKeeper so that
     * the public methods will not be exposed as part of the ZooKeeper client
     * API.
     */
<span class="fc" id="L130">    private static class ZKWatchManager implements ClientWatchManager {</span>
<span class="fc" id="L131">        private final Map&lt;String, Set&lt;Watcher&gt;&gt; dataWatches =</span>
            new HashMap&lt;String, Set&lt;Watcher&gt;&gt;();
<span class="fc" id="L133">        private final Map&lt;String, Set&lt;Watcher&gt;&gt; existWatches =</span>
            new HashMap&lt;String, Set&lt;Watcher&gt;&gt;();
<span class="fc" id="L135">        private final Map&lt;String, Set&lt;Watcher&gt;&gt; childWatches =</span>
            new HashMap&lt;String, Set&lt;Watcher&gt;&gt;();

        private volatile Watcher defaultWatcher;

        final private void addTo(Set&lt;Watcher&gt; from, Set&lt;Watcher&gt; to) {
<span class="fc bfc" id="L141" title="All 2 branches covered.">            if (from != null) {</span>
<span class="fc" id="L142">                to.addAll(from);</span>
            }
<span class="fc" id="L144">        }</span>

        /* (non-Javadoc)
         * @see org.apache.zookeeper.ClientWatchManager#materialize(Event.KeeperState, 
         *                                                        Event.EventType, java.lang.String)
         */
        @Override
        public Set&lt;Watcher&gt; materialize(Watcher.Event.KeeperState state,
                                        Watcher.Event.EventType type,
                                        String clientPath)
        {
<span class="fc" id="L155">            Set&lt;Watcher&gt; result = new HashSet&lt;Watcher&gt;();</span>

<span class="pc bpc" id="L157" title="1 of 5 branches missed.">            switch (type) {</span>
            case None:
<span class="fc" id="L159">                result.add(defaultWatcher);</span>
<span class="fc bfc" id="L160" title="All 4 branches covered.">                boolean clear = ClientCnxn.getDisableAutoResetWatch() &amp;&amp;</span>
                        state != Watcher.Event.KeeperState.SyncConnected;

<span class="fc" id="L163">                synchronized(dataWatches) {</span>
<span class="fc bfc" id="L164" title="All 2 branches covered.">                    for(Set&lt;Watcher&gt; ws: dataWatches.values()) {</span>
<span class="fc" id="L165">                        result.addAll(ws);</span>
<span class="fc" id="L166">                    }</span>
<span class="fc bfc" id="L167" title="All 2 branches covered.">                    if (clear) {</span>
<span class="fc" id="L168">                        dataWatches.clear();</span>
                    }
<span class="pc" id="L170">                }</span>

<span class="fc" id="L172">                synchronized(existWatches) {</span>
<span class="fc bfc" id="L173" title="All 2 branches covered.">                    for(Set&lt;Watcher&gt; ws: existWatches.values()) {</span>
<span class="fc" id="L174">                        result.addAll(ws);</span>
<span class="fc" id="L175">                    }</span>
<span class="fc bfc" id="L176" title="All 2 branches covered.">                    if (clear) {</span>
<span class="fc" id="L177">                        existWatches.clear();</span>
                    }
<span class="pc" id="L179">                }</span>

<span class="fc" id="L181">                synchronized(childWatches) {</span>
<span class="fc bfc" id="L182" title="All 2 branches covered.">                    for(Set&lt;Watcher&gt; ws: childWatches.values()) {</span>
<span class="fc" id="L183">                        result.addAll(ws);</span>
<span class="fc" id="L184">                    }</span>
<span class="fc bfc" id="L185" title="All 2 branches covered.">                    if (clear) {</span>
<span class="fc" id="L186">                        childWatches.clear();</span>
                    }
<span class="pc" id="L188">                }</span>

<span class="fc" id="L190">                return result;</span>
            case NodeDataChanged:
            case NodeCreated:
<span class="fc" id="L193">                synchronized (dataWatches) {</span>
<span class="fc" id="L194">                    addTo(dataWatches.remove(clientPath), result);</span>
<span class="pc" id="L195">                }</span>
<span class="fc" id="L196">                synchronized (existWatches) {</span>
<span class="fc" id="L197">                    addTo(existWatches.remove(clientPath), result);</span>
<span class="pc" id="L198">                }</span>
<span class="fc" id="L199">                break;</span>
            case NodeChildrenChanged:
<span class="fc" id="L201">                synchronized (childWatches) {</span>
<span class="fc" id="L202">                    addTo(childWatches.remove(clientPath), result);</span>
<span class="pc" id="L203">                }</span>
<span class="fc" id="L204">                break;</span>
            case NodeDeleted:
<span class="fc" id="L206">                synchronized (dataWatches) {</span>
<span class="fc" id="L207">                    addTo(dataWatches.remove(clientPath), result);</span>
<span class="pc" id="L208">                }</span>
                // XXX This shouldn't be needed, but just in case
<span class="fc" id="L210">                synchronized (existWatches) {</span>
<span class="fc" id="L211">                    Set&lt;Watcher&gt; list = existWatches.remove(clientPath);</span>
<span class="pc bpc" id="L212" title="1 of 2 branches missed.">                    if (list != null) {</span>
<span class="nc" id="L213">                        addTo(existWatches.remove(clientPath), result);</span>
<span class="nc" id="L214">                        LOG.warn(&quot;We are triggering an exists watch for delete! Shouldn't happen!&quot;);</span>
                    }
<span class="pc" id="L216">                }</span>
<span class="fc" id="L217">                synchronized (childWatches) {</span>
<span class="fc" id="L218">                    addTo(childWatches.remove(clientPath), result);</span>
<span class="pc" id="L219">                }</span>
<span class="fc" id="L220">                break;</span>
            default:
<span class="nc" id="L222">                String msg = &quot;Unhandled watch event type &quot; + type</span>
                    + &quot; with state &quot; + state + &quot; on path &quot; + clientPath;
<span class="nc" id="L224">                LOG.error(msg);</span>
<span class="nc" id="L225">                throw new RuntimeException(msg);</span>
            }

<span class="fc" id="L228">            return result;</span>
        }
    }

    /**
     * Register a watcher for a particular path.
     */
    abstract class WatchRegistration {
        private Watcher watcher;
        private String clientPath;
        public WatchRegistration(Watcher watcher, String clientPath)
<span class="fc" id="L239">        {</span>
<span class="fc" id="L240">            this.watcher = watcher;</span>
<span class="fc" id="L241">            this.clientPath = clientPath;</span>
<span class="fc" id="L242">        }</span>

        abstract protected Map&lt;String, Set&lt;Watcher&gt;&gt; getWatches(int rc);

        /**
         * Register the watcher with the set of watches on path.
         * @param rc the result code of the operation that attempted to
         * add the watch on the path.
         */
        public void register(int rc) {
<span class="fc bfc" id="L252" title="All 2 branches covered.">            if (shouldAddWatch(rc)) {</span>
<span class="fc" id="L253">                Map&lt;String, Set&lt;Watcher&gt;&gt; watches = getWatches(rc);</span>
<span class="fc" id="L254">                synchronized(watches) {</span>
<span class="fc" id="L255">                    Set&lt;Watcher&gt; watchers = watches.get(clientPath);</span>
<span class="fc bfc" id="L256" title="All 2 branches covered.">                    if (watchers == null) {</span>
<span class="fc" id="L257">                        watchers = new HashSet&lt;Watcher&gt;();</span>
<span class="fc" id="L258">                        watches.put(clientPath, watchers);</span>
                    }
<span class="fc" id="L260">                    watchers.add(watcher);</span>
<span class="pc" id="L261">                }</span>
            }
<span class="fc" id="L263">        }</span>
        /**
         * Determine whether the watch should be added based on return code.
         * @param rc the result code of the operation that attempted to add the
         * watch on the node
         * @return true if the watch should be added, otw false
         */
        protected boolean shouldAddWatch(int rc) {
<span class="fc bfc" id="L271" title="All 2 branches covered.">            return rc == 0;</span>
        }
    }

    /** Handle the special case of exists watches - they add a watcher
     * even in the case where NONODE result code is returned.
     */
    class ExistsWatchRegistration extends WatchRegistration {
<span class="fc" id="L279">        public ExistsWatchRegistration(Watcher watcher, String clientPath) {</span>
<span class="fc" id="L280">            super(watcher, clientPath);</span>
<span class="fc" id="L281">        }</span>

        @Override
        protected Map&lt;String, Set&lt;Watcher&gt;&gt; getWatches(int rc) {
<span class="fc bfc" id="L285" title="All 2 branches covered.">            return rc == 0 ?  watchManager.dataWatches : watchManager.existWatches;</span>
        }

        @Override
        protected boolean shouldAddWatch(int rc) {
<span class="fc bfc" id="L290" title="All 4 branches covered.">            return rc == 0 || rc == KeeperException.Code.NONODE.intValue();</span>
        }
    }

    class DataWatchRegistration extends WatchRegistration {
<span class="fc" id="L295">        public DataWatchRegistration(Watcher watcher, String clientPath) {</span>
<span class="fc" id="L296">            super(watcher, clientPath);</span>
<span class="fc" id="L297">        }</span>

        @Override
        protected Map&lt;String, Set&lt;Watcher&gt;&gt; getWatches(int rc) {
<span class="fc" id="L301">            return watchManager.dataWatches;</span>
        }
    }

    class ChildWatchRegistration extends WatchRegistration {
<span class="fc" id="L306">        public ChildWatchRegistration(Watcher watcher, String clientPath) {</span>
<span class="fc" id="L307">            super(watcher, clientPath);</span>
<span class="fc" id="L308">        }</span>

        @Override
        protected Map&lt;String, Set&lt;Watcher&gt;&gt; getWatches(int rc) {
<span class="fc" id="L312">            return watchManager.childWatches;</span>
        }
    }

<span class="pc" id="L316">    public enum States {</span>
<span class="fc" id="L317">        CONNECTING, ASSOCIATING, CONNECTED, CONNECTEDREADONLY,</span>
<span class="fc" id="L318">        CLOSED, AUTH_FAILED, NOT_CONNECTED;</span>

        public boolean isAlive() {
<span class="fc bfc" id="L321" title="All 4 branches covered.">            return this != CLOSED &amp;&amp; this != AUTH_FAILED;</span>
        }

        /**
         * Returns whether we are connected to a server (which
         * could possibly be read-only, if this client is allowed
         * to go to read-only mode)
         * */
        public boolean isConnected() {
<span class="fc bfc" id="L330" title="All 4 branches covered.">            return this == CONNECTED || this == CONNECTEDREADONLY;</span>
        }
    }

    /**
     * To create a ZooKeeper client object, the application needs to pass a
     * connection string containing a comma separated list of host:port pairs,
     * each corresponding to a ZooKeeper server.
     * &lt;p&gt;
     * Session establishment is asynchronous. This constructor will initiate
     * connection to the server and return immediately - potentially (usually)
     * before the session is fully established. The watcher argument specifies
     * the watcher that will be notified of any changes in state. This
     * notification can come at any point before or after the constructor call
     * has returned.
     * &lt;p&gt;
     * The instantiated ZooKeeper client object will pick an arbitrary server
     * from the connectString and attempt to connect to it. If establishment of
     * the connection fails, another server in the connect string will be tried
     * (the order is non-deterministic, as we random shuffle the list), until a
     * connection is established. The client will continue attempts until the
     * session is explicitly closed.
     * &lt;p&gt;
     * Added in 3.2.0: An optional &quot;chroot&quot; suffix may also be appended to the
     * connection string. This will run the client commands while interpreting
     * all paths relative to this root (similar to the unix chroot command).
     *
     * @param connectString
     *            comma separated host:port pairs, each corresponding to a zk
     *            server. e.g. &quot;127.0.0.1:3000,127.0.0.1:3001,127.0.0.1:3002&quot; If
     *            the optional chroot suffix is used the example would look
     *            like: &quot;127.0.0.1:3000,127.0.0.1:3001,127.0.0.1:3002/app/a&quot;
     *            where the client would be rooted at &quot;/app/a&quot; and all paths
     *            would be relative to this root - ie getting/setting/etc...
     *            &quot;/foo/bar&quot; would result in operations being run on
     *            &quot;/app/a/foo/bar&quot; (from the server perspective).
     * @param sessionTimeout
     *            session timeout in milliseconds
     * @param watcher
     *            a watcher object which will be notified of state changes, may
     *            also be notified for node events
     *
     * @throws IOException
     *             in cases of network failure
     * @throws IllegalArgumentException
     *             if an invalid chroot path is specified
     */
    public ZooKeeper(String connectString, int sessionTimeout, Watcher watcher)
        throws IOException
    {
<span class="fc" id="L380">        this(connectString, sessionTimeout, watcher, false);</span>
<span class="fc" id="L381">    }</span>

    /**
     * To create a ZooKeeper client object, the application needs to pass a
     * connection string containing a comma separated list of host:port pairs,
     * each corresponding to a ZooKeeper server.
     * &lt;p&gt;
     * Session establishment is asynchronous. This constructor will initiate
     * connection to the server and return immediately - potentially (usually)
     * before the session is fully established. The watcher argument specifies
     * the watcher that will be notified of any changes in state. This
     * notification can come at any point before or after the constructor call
     * has returned.
     * &lt;p&gt;
     * The instantiated ZooKeeper client object will pick an arbitrary server
     * from the connectString and attempt to connect to it. If establishment of
     * the connection fails, another server in the connect string will be tried
     * (the order is non-deterministic, as we random shuffle the list), until a
     * connection is established. The client will continue attempts until the
     * session is explicitly closed.
     * &lt;p&gt;
     * Added in 3.2.0: An optional &quot;chroot&quot; suffix may also be appended to the
     * connection string. This will run the client commands while interpreting
     * all paths relative to this root (similar to the unix chroot command).
     *
     * @param connectString
     *            comma separated host:port pairs, each corresponding to a zk
     *            server. e.g. &quot;127.0.0.1:3000,127.0.0.1:3001,127.0.0.1:3002&quot; If
     *            the optional chroot suffix is used the example would look
     *            like: &quot;127.0.0.1:3000,127.0.0.1:3001,127.0.0.1:3002/app/a&quot;
     *            where the client would be rooted at &quot;/app/a&quot; and all paths
     *            would be relative to this root - ie getting/setting/etc...
     *            &quot;/foo/bar&quot; would result in operations being run on
     *            &quot;/app/a/foo/bar&quot; (from the server perspective).
     * @param sessionTimeout
     *            session timeout in milliseconds
     * @param watcher
     *            a watcher object which will be notified of state changes, may
     *            also be notified for node events
     * @param canBeReadOnly
     *            (added in 3.4) whether the created client is allowed to go to
     *            read-only mode in case of partitioning. Read-only mode
     *            basically means that if the client can't find any majority
     *            servers but there's partitioned server it could reach, it
     *            connects to one in read-only mode, i.e. read requests are
     *            allowed while write requests are not. It continues seeking for
     *            majority in the background.
     *
     * @throws IOException
     *             in cases of network failure
     * @throws IllegalArgumentException
     *             if an invalid chroot path is specified
     */
    public ZooKeeper(String connectString, int sessionTimeout, Watcher watcher,
            boolean canBeReadOnly)
        throws IOException
<span class="fc" id="L437">    {</span>
<span class="fc" id="L438">        LOG.info(&quot;Initiating client connection, connectString=&quot; + connectString</span>
                + &quot; sessionTimeout=&quot; + sessionTimeout + &quot; watcher=&quot; + watcher);

<span class="fc" id="L441">        watchManager.defaultWatcher = watcher;</span>

<span class="fc" id="L443">        ConnectStringParser connectStringParser = new ConnectStringParser(</span>
                connectString);
<span class="fc" id="L445">        HostProvider hostProvider = new StaticHostProvider(</span>
<span class="fc" id="L446">                connectStringParser.getServerAddresses());</span>
<span class="fc" id="L447">        cnxn = new ClientCnxn(connectStringParser.getChrootPath(),</span>
                hostProvider, sessionTimeout, this, watchManager,
<span class="fc" id="L449">                getClientCnxnSocket(), canBeReadOnly);</span>
<span class="fc" id="L450">        cnxn.start();</span>
<span class="fc" id="L451">    }</span>

    /**
     * To create a ZooKeeper client object, the application needs to pass a
     * connection string containing a comma separated list of host:port pairs,
     * each corresponding to a ZooKeeper server.
     * &lt;p&gt;
     * Session establishment is asynchronous. This constructor will initiate
     * connection to the server and return immediately - potentially (usually)
     * before the session is fully established. The watcher argument specifies
     * the watcher that will be notified of any changes in state. This
     * notification can come at any point before or after the constructor call
     * has returned.
     * &lt;p&gt;
     * The instantiated ZooKeeper client object will pick an arbitrary server
     * from the connectString and attempt to connect to it. If establishment of
     * the connection fails, another server in the connect string will be tried
     * (the order is non-deterministic, as we random shuffle the list), until a
     * connection is established. The client will continue attempts until the
     * session is explicitly closed (or the session is expired by the server).
     * &lt;p&gt;
     * Added in 3.2.0: An optional &quot;chroot&quot; suffix may also be appended to the
     * connection string. This will run the client commands while interpreting
     * all paths relative to this root (similar to the unix chroot command).
     * &lt;p&gt;
     * Use {@link #getSessionId} and {@link #getSessionPasswd} on an established
     * client connection, these values must be passed as sessionId and
     * sessionPasswd respectively if reconnecting. Otherwise, if not
     * reconnecting, use the other constructor which does not require these
     * parameters.
     *
     * @param connectString
     *            comma separated host:port pairs, each corresponding to a zk
     *            server. e.g. &quot;127.0.0.1:3000,127.0.0.1:3001,127.0.0.1:3002&quot;
     *            If the optional chroot suffix is used the example would look
     *            like: &quot;127.0.0.1:3000,127.0.0.1:3001,127.0.0.1:3002/app/a&quot;
     *            where the client would be rooted at &quot;/app/a&quot; and all paths
     *            would be relative to this root - ie getting/setting/etc...
     *            &quot;/foo/bar&quot; would result in operations being run on
     *            &quot;/app/a/foo/bar&quot; (from the server perspective).
     * @param sessionTimeout
     *            session timeout in milliseconds
     * @param watcher
     *            a watcher object which will be notified of state changes, may
     *            also be notified for node events
     * @param sessionId
     *            specific session id to use if reconnecting
     * @param sessionPasswd
     *            password for this session
     *
     * @throws IOException in cases of network failure
     * @throws IllegalArgumentException if an invalid chroot path is specified
     * @throws IllegalArgumentException for an invalid list of ZooKeeper hosts
     */
    public ZooKeeper(String connectString, int sessionTimeout, Watcher watcher,
            long sessionId, byte[] sessionPasswd)
        throws IOException
    {
<span class="fc" id="L509">        this(connectString, sessionTimeout, watcher, sessionId, sessionPasswd, false);</span>
<span class="fc" id="L510">    }</span>

    /**
     * To create a ZooKeeper client object, the application needs to pass a
     * connection string containing a comma separated list of host:port pairs,
     * each corresponding to a ZooKeeper server.
     * &lt;p&gt;
     * Session establishment is asynchronous. This constructor will initiate
     * connection to the server and return immediately - potentially (usually)
     * before the session is fully established. The watcher argument specifies
     * the watcher that will be notified of any changes in state. This
     * notification can come at any point before or after the constructor call
     * has returned.
     * &lt;p&gt;
     * The instantiated ZooKeeper client object will pick an arbitrary server
     * from the connectString and attempt to connect to it. If establishment of
     * the connection fails, another server in the connect string will be tried
     * (the order is non-deterministic, as we random shuffle the list), until a
     * connection is established. The client will continue attempts until the
     * session is explicitly closed (or the session is expired by the server).
     * &lt;p&gt;
     * Added in 3.2.0: An optional &quot;chroot&quot; suffix may also be appended to the
     * connection string. This will run the client commands while interpreting
     * all paths relative to this root (similar to the unix chroot command).
     * &lt;p&gt;
     * Use {@link #getSessionId} and {@link #getSessionPasswd} on an established
     * client connection, these values must be passed as sessionId and
     * sessionPasswd respectively if reconnecting. Otherwise, if not
     * reconnecting, use the other constructor which does not require these
     * parameters.
     *
     * @param connectString
     *            comma separated host:port pairs, each corresponding to a zk
     *            server. e.g. &quot;127.0.0.1:3000,127.0.0.1:3001,127.0.0.1:3002&quot;
     *            If the optional chroot suffix is used the example would look
     *            like: &quot;127.0.0.1:3000,127.0.0.1:3001,127.0.0.1:3002/app/a&quot;
     *            where the client would be rooted at &quot;/app/a&quot; and all paths
     *            would be relative to this root - ie getting/setting/etc...
     *            &quot;/foo/bar&quot; would result in operations being run on
     *            &quot;/app/a/foo/bar&quot; (from the server perspective).
     * @param sessionTimeout
     *            session timeout in milliseconds
     * @param watcher
     *            a watcher object which will be notified of state changes, may
     *            also be notified for node events
     * @param sessionId
     *            specific session id to use if reconnecting
     * @param sessionPasswd
     *            password for this session
     * @param canBeReadOnly
     *            (added in 3.4) whether the created client is allowed to go to
     *            read-only mode in case of partitioning. Read-only mode
     *            basically means that if the client can't find any majority
     *            servers but there's partitioned server it could reach, it
     *            connects to one in read-only mode, i.e. read requests are
     *            allowed while write requests are not. It continues seeking for
     *            majority in the background.
     *
     * @throws IOException in cases of network failure
     * @throws IllegalArgumentException if an invalid chroot path is specified
     */
    public ZooKeeper(String connectString, int sessionTimeout, Watcher watcher,
            long sessionId, byte[] sessionPasswd, boolean canBeReadOnly)
        throws IOException
<span class="fc" id="L574">    {</span>
<span class="fc" id="L575">        LOG.info(&quot;Initiating client connection, connectString=&quot; + connectString</span>
                + &quot; sessionTimeout=&quot; + sessionTimeout
                + &quot; watcher=&quot; + watcher
<span class="pc bpc" id="L578" title="1 of 2 branches missed.">                + &quot; sessionId=&quot; + Long.toHexString(sessionId)</span>
                + &quot; sessionPasswd=&quot;
                + (sessionPasswd == null ? &quot;&lt;null&gt;&quot; : &quot;&lt;hidden&gt;&quot;));

<span class="fc" id="L582">        watchManager.defaultWatcher = watcher;</span>

<span class="fc" id="L584">        ConnectStringParser connectStringParser = new ConnectStringParser(</span>
                connectString);
<span class="fc" id="L586">        HostProvider hostProvider = new StaticHostProvider(</span>
<span class="fc" id="L587">                connectStringParser.getServerAddresses());</span>
<span class="fc" id="L588">        cnxn = new ClientCnxn(connectStringParser.getChrootPath(),</span>
                hostProvider, sessionTimeout, this, watchManager,
<span class="fc" id="L590">                getClientCnxnSocket(), sessionId, sessionPasswd, canBeReadOnly);</span>
<span class="fc" id="L591">        cnxn.seenRwServerBefore = true; // since user has provided sessionId</span>
<span class="fc" id="L592">        cnxn.start();</span>
<span class="fc" id="L593">    }</span>

    /**
     * The session id for this ZooKeeper client instance. The value returned is
     * not valid until the client connects to a server and may change after a
     * re-connect.
     *
     * This method is NOT thread safe
     *
     * @return current session id
     */
    public long getSessionId() {
<span class="fc" id="L605">        return cnxn.getSessionId();</span>
    }

    /**
     * The session password for this ZooKeeper client instance. The value
     * returned is not valid until the client connects to a server and may
     * change after a re-connect.
     *
     * This method is NOT thread safe
     *
     * @return current session password
     */
    public byte[] getSessionPasswd() {
<span class="fc" id="L618">        return cnxn.getSessionPasswd();</span>
    }

    /**
     * The negotiated session timeout for this ZooKeeper client instance. The
     * value returned is not valid until the client connects to a server and
     * may change after a re-connect.
     *
     * This method is NOT thread safe
     *
     * @return current session timeout
     */
    public int getSessionTimeout() {
<span class="fc" id="L631">        return cnxn.getSessionTimeout();</span>
    }

    /**
     * Add the specified scheme:auth information to this connection.
     *
     * This method is NOT thread safe
     *
     * @param scheme
     * @param auth
     */
    public void addAuthInfo(String scheme, byte auth[]) {
<span class="fc" id="L643">        cnxn.addAuthInfo(scheme, auth);</span>
<span class="fc" id="L644">    }</span>

    /**
     * Specify the default watcher for the connection (overrides the one
     * specified during construction).
     *
     * @param watcher
     */
    public synchronized void register(Watcher watcher) {
<span class="nc" id="L653">        watchManager.defaultWatcher = watcher;</span>
<span class="nc" id="L654">    }</span>

    /**
     * Close this client object. Once the client is closed, its session becomes
     * invalid. All the ephemeral nodes in the ZooKeeper server associated with
     * the session will be removed. The watches left on those nodes (and on
     * their parents) will be triggered.
     *
     * @throws InterruptedException
     */
    public synchronized void close() throws InterruptedException {
<span class="fc bfc" id="L665" title="All 2 branches covered.">        if (!cnxn.getState().isAlive()) {</span>
<span class="pc bpc" id="L666" title="1 of 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L667">                LOG.debug(&quot;Close called on already closed client&quot;);</span>
            }
<span class="fc" id="L669">            return;</span>
        }

<span class="pc bpc" id="L672" title="1 of 2 branches missed.">        if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L673">            LOG.debug(&quot;Closing session: 0x&quot; + Long.toHexString(getSessionId()));</span>
        }

        try {
<span class="fc" id="L677">            cnxn.close();</span>
<span class="nc" id="L678">        } catch (IOException e) {</span>
<span class="nc bnc" id="L679" title="All 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L680">                LOG.debug(&quot;Ignoring unexpected exception during close&quot;, e);</span>
            }
<span class="fc" id="L682">        }</span>

<span class="fc" id="L684">        LOG.info(&quot;Session: 0x&quot; + Long.toHexString(getSessionId()) + &quot; closed&quot;);</span>
<span class="fc" id="L685">    }</span>

    /**
     * Prepend the chroot to the client path (if present). The expectation of
     * this function is that the client path has been validated before this
     * function is called
     * @param clientPath path to the node
     * @return server view of the path (chroot prepended to client path)
     */
    private String prependChroot(String clientPath) {
<span class="fc bfc" id="L695" title="All 2 branches covered.">        if (cnxn.chrootPath != null) {</span>
            // handle clientPath = &quot;/&quot;
<span class="fc bfc" id="L697" title="All 2 branches covered.">            if (clientPath.length() == 1) {</span>
<span class="fc" id="L698">                return cnxn.chrootPath;</span>
            }
<span class="fc" id="L700">            return cnxn.chrootPath + clientPath;</span>
        } else {
<span class="fc" id="L702">            return clientPath;</span>
        }
    }

    /**
     * Create a node with the given path. The node data will be the given data,
     * and node acl will be the given acl.
     * &lt;p&gt;
     * The flags argument specifies whether the created node will be ephemeral
     * or not.
     * &lt;p&gt;
     * An ephemeral node will be removed by the ZooKeeper automatically when the
     * session associated with the creation of the node expires.
     * &lt;p&gt;
     * The flags argument can also specify to create a sequential node. The
     * actual path name of a sequential node will be the given path plus a
     * suffix &quot;i&quot; where i is the current sequential number of the node. The sequence
     * number is always fixed length of 10 digits, 0 padded. Once
     * such a node is created, the sequential number will be incremented by one.
     * &lt;p&gt;
     * If a node with the same actual path already exists in the ZooKeeper, a
     * KeeperException with error code KeeperException.NodeExists will be
     * thrown. Note that since a different actual path is used for each
     * invocation of creating sequential node with the same path argument, the
     * call will never throw &quot;file exists&quot; KeeperException.
     * &lt;p&gt;
     * If the parent node does not exist in the ZooKeeper, a KeeperException
     * with error code KeeperException.NoNode will be thrown.
     * &lt;p&gt;
     * An ephemeral node cannot have children. If the parent node of the given
     * path is ephemeral, a KeeperException with error code
     * KeeperException.NoChildrenForEphemerals will be thrown.
     * &lt;p&gt;
     * This operation, if successful, will trigger all the watches left on the
     * node of the given path by exists and getData API calls, and the watches
     * left on the parent node by getChildren API calls.
     * &lt;p&gt;
     * If a node is created successfully, the ZooKeeper server will trigger the
     * watches on the path left by exists calls, and the watches on the parent
     * of the node by getChildren calls.
     * &lt;p&gt;
     * The maximum allowable size of the data array is 1 MB (1,048,576 bytes).
     * Arrays larger than this will cause a KeeperExecption to be thrown.
     *
     * @param path
     *                the path for the node
     * @param data
     *                the initial data for the node
     * @param acl
     *                the acl for the node
     * @param createMode
     *                specifying whether the node to be created is ephemeral
     *                and/or sequential
     * @return the actual path of the created node
     * @throws KeeperException if the server returns a non-zero error code
     * @throws KeeperException.InvalidACLException if the ACL is invalid, null, or empty
     * @throws InterruptedException if the transaction is interrupted
     * @throws IllegalArgumentException if an invalid path is specified
     */
    public String create(final String path, byte data[], List&lt;ACL&gt; acl,
            CreateMode createMode)
        throws KeeperException, InterruptedException
    {
<span class="fc" id="L765">        final String clientPath = path;</span>
<span class="fc" id="L766">        PathUtils.validatePath(clientPath, createMode.isSequential());</span>

<span class="fc" id="L768">        final String serverPath = prependChroot(clientPath);</span>

<span class="fc" id="L770">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L771">        h.setType(ZooDefs.OpCode.create);</span>
<span class="fc" id="L772">        CreateRequest request = new CreateRequest();</span>
<span class="fc" id="L773">        CreateResponse response = new CreateResponse();</span>
<span class="fc" id="L774">        request.setData(data);</span>
<span class="fc" id="L775">        request.setFlags(createMode.toFlag());</span>
<span class="fc" id="L776">        request.setPath(serverPath);</span>
<span class="pc bpc" id="L777" title="2 of 4 branches missed.">        if (acl != null &amp;&amp; acl.size() == 0) {</span>
<span class="nc" id="L778">            throw new KeeperException.InvalidACLException();</span>
        }
<span class="fc" id="L780">        request.setAcl(acl);</span>
<span class="fc" id="L781">        ReplyHeader r = cnxn.submitRequest(h, request, response, null);</span>
<span class="fc bfc" id="L782" title="All 2 branches covered.">        if (r.getErr() != 0) {</span>
<span class="fc" id="L783">            throw KeeperException.create(KeeperException.Code.get(r.getErr()),</span>
                    clientPath);
        }
<span class="fc bfc" id="L786" title="All 2 branches covered.">        if (cnxn.chrootPath == null) {</span>
<span class="fc" id="L787">            return response.getPath();</span>
        } else {
<span class="fc" id="L789">            return response.getPath().substring(cnxn.chrootPath.length());</span>
        }
    }

    /**
     * The asynchronous version of create.
     *
     * @see #create(String, byte[], List, CreateMode)
     */

    public void create(final String path, byte data[], List&lt;ACL&gt; acl,
            CreateMode createMode,  StringCallback cb, Object ctx)
    {
<span class="fc" id="L802">        final String clientPath = path;</span>
<span class="fc" id="L803">        PathUtils.validatePath(clientPath, createMode.isSequential());</span>

<span class="fc" id="L805">        final String serverPath = prependChroot(clientPath);</span>

<span class="fc" id="L807">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L808">        h.setType(ZooDefs.OpCode.create);</span>
<span class="fc" id="L809">        CreateRequest request = new CreateRequest();</span>
<span class="fc" id="L810">        CreateResponse response = new CreateResponse();</span>
<span class="fc" id="L811">        ReplyHeader r = new ReplyHeader();</span>
<span class="fc" id="L812">        request.setData(data);</span>
<span class="fc" id="L813">        request.setFlags(createMode.toFlag());</span>
<span class="fc" id="L814">        request.setPath(serverPath);</span>
<span class="fc" id="L815">        request.setAcl(acl);</span>
<span class="fc" id="L816">        cnxn.queuePacket(h, r, request, response, cb, clientPath,</span>
                serverPath, ctx, null);
<span class="fc" id="L818">    }</span>

    /**
     * Delete the node with the given path. The call will succeed if such a node
     * exists, and the given version matches the node's version (if the given
     * version is -1, it matches any node's versions).
     * &lt;p&gt;
     * A KeeperException with error code KeeperException.NoNode will be thrown
     * if the nodes does not exist.
     * &lt;p&gt;
     * A KeeperException with error code KeeperException.BadVersion will be
     * thrown if the given version does not match the node's version.
     * &lt;p&gt;
     * A KeeperException with error code KeeperException.NotEmpty will be thrown
     * if the node has children.
     * &lt;p&gt;
     * This operation, if successful, will trigger all the watches on the node
     * of the given path left by exists API calls, and the watches on the parent
     * node left by getChildren API calls.
     *
     * @param path
     *                the path of the node to be deleted.
     * @param version
     *                the expected node version.
     * @throws InterruptedException IF the server transaction is interrupted
     * @throws KeeperException If the server signals an error with a non-zero
     *   return code.
     * @throws IllegalArgumentException if an invalid path is specified
     */
    public void delete(final String path, int version)
        throws InterruptedException, KeeperException
    {
<span class="fc" id="L850">        final String clientPath = path;</span>
<span class="fc" id="L851">        PathUtils.validatePath(clientPath);</span>

        final String serverPath;

        // maintain semantics even in chroot case
        // specifically - root cannot be deleted
        // I think this makes sense even in chroot case.
<span class="fc bfc" id="L858" title="All 2 branches covered.">        if (clientPath.equals(&quot;/&quot;)) {</span>
            // a bit of a hack, but delete(/) will never succeed and ensures
            // that the same semantics are maintained
<span class="fc" id="L861">            serverPath = clientPath;</span>
        } else {
<span class="fc" id="L863">            serverPath = prependChroot(clientPath);</span>
        }

<span class="fc" id="L866">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L867">        h.setType(ZooDefs.OpCode.delete);</span>
<span class="fc" id="L868">        DeleteRequest request = new DeleteRequest();</span>
<span class="fc" id="L869">        request.setPath(serverPath);</span>
<span class="fc" id="L870">        request.setVersion(version);</span>
<span class="fc" id="L871">        ReplyHeader r = cnxn.submitRequest(h, request, null, null);</span>
<span class="fc bfc" id="L872" title="All 2 branches covered.">        if (r.getErr() != 0) {</span>
<span class="fc" id="L873">            throw KeeperException.create(KeeperException.Code.get(r.getErr()),</span>
                    clientPath);
        }
<span class="fc" id="L876">    }</span>

    /**
     * Executes multiple ZooKeeper operations or none of them.
     * &lt;p&gt;
     * On success, a list of results is returned.
     * On failure, an exception is raised which contains partial results and
     * error details, see {@link KeeperException#getResults}
     * &lt;p&gt;
     * Note: The maximum allowable size of all of the data arrays in all of
     * the setData operations in this single request is typically 1 MB
     * (1,048,576 bytes). This limit is specified on the server via
     * &lt;a href=&quot;http://zookeeper.apache.org/doc/current/zookeeperAdmin.html#Unsafe+Options&quot;&gt;jute.maxbuffer&lt;/a&gt;.
     * Requests larger than this will cause a KeeperException to be
     * thrown.
     *
     * @param ops An iterable that contains the operations to be done.
     * These should be created using the factory methods on {@link Op}.
     * @return A list of results, one for each input Op, the order of
     * which exactly matches the order of the &lt;code&gt;ops&lt;/code&gt; input
     * operations.
     * @throws InterruptedException If the operation was interrupted.
     * The operation may or may not have succeeded, but will not have
     * partially succeeded if this exception is thrown.
     * @throws KeeperException If the operation could not be completed
     * due to some error in doing one of the specified ops.
     * @throws IllegalArgumentException if an invalid path is specified
     *
     * @since 3.4.0
     */
    public List&lt;OpResult&gt; multi(Iterable&lt;Op&gt; ops) throws InterruptedException, KeeperException {
<span class="fc bfc" id="L907" title="All 2 branches covered.">        for (Op op : ops) {</span>
<span class="fc" id="L908">            op.validate();</span>
<span class="fc" id="L909">        }</span>
<span class="fc" id="L910">        return multiInternal(generateMultiTransaction(ops));</span>
    }

    /**
     * The asynchronous version of multi.
     *
     * @see #multi(Iterable)
     * @since 3.4.7
     */
    public void multi(Iterable&lt;Op&gt; ops, MultiCallback cb, Object ctx) {
<span class="fc" id="L920">        List&lt;OpResult&gt; results = validatePath(ops);</span>
<span class="fc bfc" id="L921" title="All 2 branches covered.">        if (results.size() &gt; 0) {</span>
<span class="fc" id="L922">            cb.processResult(KeeperException.Code.BADARGUMENTS.intValue(),</span>
                             null, ctx, results);
<span class="fc" id="L924">            return;</span>
        }
<span class="fc" id="L926">        multiInternal(generateMultiTransaction(ops), cb, ctx);</span>
<span class="fc" id="L927">    }</span>

    private List&lt;OpResult&gt; validatePath(Iterable&lt;Op&gt; ops) {
<span class="fc" id="L930">        List&lt;OpResult&gt; results = new ArrayList&lt;OpResult&gt;();</span>
<span class="fc" id="L931">        boolean error = false;</span>
<span class="fc bfc" id="L932" title="All 2 branches covered.">        for (Op op : ops) {</span>
            try {
<span class="fc" id="L934">                op.validate();</span>
<span class="fc" id="L935">            } catch (IllegalArgumentException iae) {</span>
<span class="fc" id="L936">                LOG.error(&quot;IllegalArgumentException: &quot; + iae.getMessage());</span>
<span class="fc" id="L937">                ErrorResult err = new ErrorResult(</span>
<span class="fc" id="L938">                        KeeperException.Code.BADARGUMENTS.intValue());</span>
<span class="fc" id="L939">                results.add(err);</span>
<span class="fc" id="L940">                error = true;</span>
<span class="fc" id="L941">                continue;</span>
<span class="fc" id="L942">            } catch (KeeperException ke) {</span>
<span class="fc" id="L943">                LOG.error(&quot;KeeperException: &quot; + ke.getMessage());</span>
<span class="fc" id="L944">                ErrorResult err = new ErrorResult(ke.code().intValue());</span>
<span class="fc" id="L945">                results.add(err);</span>
<span class="fc" id="L946">                error = true;</span>
<span class="fc" id="L947">                continue;</span>
<span class="fc" id="L948">            }</span>
<span class="fc" id="L949">            ErrorResult err = new ErrorResult(</span>
<span class="fc" id="L950">                    KeeperException.Code.RUNTIMEINCONSISTENCY.intValue());</span>
<span class="fc" id="L951">            results.add(err);</span>
<span class="fc" id="L952">        }</span>
<span class="fc bfc" id="L953" title="All 2 branches covered.">        if (false == error) {</span>
<span class="fc" id="L954">            results.clear();</span>
        }
<span class="fc" id="L956">        return results;</span>
    }

    private MultiTransactionRecord generateMultiTransaction(Iterable&lt;Op&gt; ops) {
<span class="fc" id="L960">        List&lt;Op&gt; transaction = new ArrayList&lt;Op&gt;();</span>

<span class="fc bfc" id="L962" title="All 2 branches covered.">        for (Op op : ops) {</span>
<span class="fc" id="L963">            transaction.add(withRootPrefix(op));</span>
<span class="fc" id="L964">        }</span>
<span class="fc" id="L965">        return new MultiTransactionRecord(transaction);</span>
    }

    private Op withRootPrefix(Op op) {
<span class="pc bpc" id="L969" title="1 of 2 branches missed.">        if (null != op.getPath()) {</span>
<span class="fc" id="L970">            final String serverPath = prependChroot(op.getPath());</span>
<span class="fc bfc" id="L971" title="All 2 branches covered.">            if (!op.getPath().equals(serverPath)) {</span>
<span class="fc" id="L972">                return op.withChroot(serverPath);</span>
            }
        }
<span class="fc" id="L975">        return op;</span>
    }

    protected void multiInternal(MultiTransactionRecord request, MultiCallback cb, Object ctx) {
<span class="fc" id="L979">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L980">        h.setType(ZooDefs.OpCode.multi);</span>
<span class="fc" id="L981">        MultiResponse response = new MultiResponse();</span>
<span class="fc" id="L982">        cnxn.queuePacket(h, new ReplyHeader(), request, response, cb, null, null, ctx, null);</span>
<span class="fc" id="L983">    }</span>

    protected List&lt;OpResult&gt; multiInternal(MultiTransactionRecord request)
        throws InterruptedException, KeeperException {
<span class="fc" id="L987">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L988">        h.setType(ZooDefs.OpCode.multi);</span>
<span class="fc" id="L989">        MultiResponse response = new MultiResponse();</span>
<span class="fc" id="L990">        ReplyHeader r = cnxn.submitRequest(h, request, response, null);</span>
<span class="fc bfc" id="L991" title="All 2 branches covered.">        if (r.getErr() != 0) {</span>
<span class="fc" id="L992">            throw KeeperException.create(KeeperException.Code.get(r.getErr()));</span>
        }

<span class="fc" id="L995">        List&lt;OpResult&gt; results = response.getResultList();</span>
        
<span class="fc" id="L997">        ErrorResult fatalError = null;</span>
<span class="fc bfc" id="L998" title="All 2 branches covered.">        for (OpResult result : results) {</span>
<span class="fc bfc" id="L999" title="All 4 branches covered.">            if (result instanceof ErrorResult &amp;&amp; ((ErrorResult)result).getErr() != KeeperException.Code.OK.intValue()) {</span>
<span class="fc" id="L1000">                fatalError = (ErrorResult) result;</span>
<span class="fc" id="L1001">                break;</span>
            }
<span class="fc" id="L1003">        }</span>

<span class="fc bfc" id="L1005" title="All 2 branches covered.">        if (fatalError != null) {</span>
<span class="fc" id="L1006">            KeeperException ex = KeeperException.create(KeeperException.Code.get(fatalError.getErr()));</span>
<span class="fc" id="L1007">            ex.setMultiResults(results);</span>
<span class="fc" id="L1008">            throw ex;</span>
        }

<span class="fc" id="L1011">        return results;</span>
    }

    /**
     * A Transaction is a thin wrapper on the {@link #multi} method
     * which provides a builder object that can be used to construct
     * and commit an atomic set of operations.
     *
     * @since 3.4.0
     *
     * @return a Transaction builder object
     */
    public Transaction transaction() {
<span class="fc" id="L1024">        return new Transaction(this);</span>
    }

    /**
     * The asynchronous version of delete.
     *
     * @see #delete(String, int)
     */
    public void delete(final String path, int version, VoidCallback cb,
            Object ctx)
    {
<span class="fc" id="L1035">        final String clientPath = path;</span>
<span class="fc" id="L1036">        PathUtils.validatePath(clientPath);</span>

        final String serverPath;

        // maintain semantics even in chroot case
        // specifically - root cannot be deleted
        // I think this makes sense even in chroot case.
<span class="pc bpc" id="L1043" title="1 of 2 branches missed.">        if (clientPath.equals(&quot;/&quot;)) {</span>
            // a bit of a hack, but delete(/) will never succeed and ensures
            // that the same semantics are maintained
<span class="nc" id="L1046">            serverPath = clientPath;</span>
        } else {
<span class="fc" id="L1048">            serverPath = prependChroot(clientPath);</span>
        }

<span class="fc" id="L1051">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L1052">        h.setType(ZooDefs.OpCode.delete);</span>
<span class="fc" id="L1053">        DeleteRequest request = new DeleteRequest();</span>
<span class="fc" id="L1054">        request.setPath(serverPath);</span>
<span class="fc" id="L1055">        request.setVersion(version);</span>
<span class="fc" id="L1056">        cnxn.queuePacket(h, new ReplyHeader(), request, null, cb, clientPath,</span>
                serverPath, ctx, null);
<span class="fc" id="L1058">    }</span>

    /**
     * Return the stat of the node of the given path. Return null if no such a
     * node exists.
     * &lt;p&gt;
     * If the watch is non-null and the call is successful (no exception is thrown),
     * a watch will be left on the node with the given path. The watch will be
     * triggered by a successful operation that creates/delete the node or sets
     * the data on the node.
     *
     * @param path the node path
     * @param watcher explicit watcher
     * @return the stat of the node of the given path; return null if no such a
     *         node exists.
     * @throws KeeperException If the server signals an error
     * @throws InterruptedException If the server transaction is interrupted.
     * @throws IllegalArgumentException if an invalid path is specified
     */
    public Stat exists(final String path, Watcher watcher)
        throws KeeperException, InterruptedException
    {
<span class="fc" id="L1080">        final String clientPath = path;</span>
<span class="fc" id="L1081">        PathUtils.validatePath(clientPath);</span>

        // the watch contains the un-chroot path
<span class="fc" id="L1084">        WatchRegistration wcb = null;</span>
<span class="fc bfc" id="L1085" title="All 2 branches covered.">        if (watcher != null) {</span>
<span class="fc" id="L1086">            wcb = new ExistsWatchRegistration(watcher, clientPath);</span>
        }

<span class="fc" id="L1089">        final String serverPath = prependChroot(clientPath);</span>

<span class="fc" id="L1091">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L1092">        h.setType(ZooDefs.OpCode.exists);</span>
<span class="fc" id="L1093">        ExistsRequest request = new ExistsRequest();</span>
<span class="fc" id="L1094">        request.setPath(serverPath);</span>
<span class="fc bfc" id="L1095" title="All 2 branches covered.">        request.setWatch(watcher != null);</span>
<span class="fc" id="L1096">        SetDataResponse response = new SetDataResponse();</span>
<span class="fc" id="L1097">        ReplyHeader r = cnxn.submitRequest(h, request, response, wcb);</span>
<span class="fc bfc" id="L1098" title="All 2 branches covered.">        if (r.getErr() != 0) {</span>
<span class="fc bfc" id="L1099" title="All 2 branches covered.">            if (r.getErr() == KeeperException.Code.NONODE.intValue()) {</span>
<span class="fc" id="L1100">                return null;</span>
            }
<span class="fc" id="L1102">            throw KeeperException.create(KeeperException.Code.get(r.getErr()),</span>
                    clientPath);
        }

<span class="pc bpc" id="L1106" title="1 of 2 branches missed.">        return response.getStat().getCzxid() == -1 ? null : response.getStat();</span>
    }

    /**
     * Return the stat of the node of the given path. Return null if no such a
     * node exists.
     * &lt;p&gt;
     * If the watch is true and the call is successful (no exception is thrown),
     * a watch will be left on the node with the given path. The watch will be
     * triggered by a successful operation that creates/delete the node or sets
     * the data on the node.
     *
     * @param path
     *                the node path
     * @param watch
     *                whether need to watch this node
     * @return the stat of the node of the given path; return null if no such a
     *         node exists.
     * @throws KeeperException If the server signals an error
     * @throws InterruptedException If the server transaction is interrupted.
     */
    public Stat exists(String path, boolean watch) throws KeeperException,
        InterruptedException
    {
<span class="fc bfc" id="L1130" title="All 2 branches covered.">        return exists(path, watch ? watchManager.defaultWatcher : null);</span>
    }

    /**
     * The asynchronous version of exists.
     *
     * @see #exists(String, Watcher)
     */
    public void exists(final String path, Watcher watcher,
            StatCallback cb, Object ctx)
    {
<span class="fc" id="L1141">        final String clientPath = path;</span>
<span class="fc" id="L1142">        PathUtils.validatePath(clientPath);</span>

        // the watch contains the un-chroot path
<span class="fc" id="L1145">        WatchRegistration wcb = null;</span>
<span class="fc bfc" id="L1146" title="All 2 branches covered.">        if (watcher != null) {</span>
<span class="fc" id="L1147">            wcb = new ExistsWatchRegistration(watcher, clientPath);</span>
        }

<span class="fc" id="L1150">        final String serverPath = prependChroot(clientPath);</span>

<span class="fc" id="L1152">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L1153">        h.setType(ZooDefs.OpCode.exists);</span>
<span class="fc" id="L1154">        ExistsRequest request = new ExistsRequest();</span>
<span class="fc" id="L1155">        request.setPath(serverPath);</span>
<span class="fc bfc" id="L1156" title="All 2 branches covered.">        request.setWatch(watcher != null);</span>
<span class="fc" id="L1157">        SetDataResponse response = new SetDataResponse();</span>
<span class="fc" id="L1158">        cnxn.queuePacket(h, new ReplyHeader(), request, response, cb,</span>
                clientPath, serverPath, ctx, wcb);
<span class="fc" id="L1160">    }</span>

    /**
     * The asynchronous version of exists.
     *
     * @see #exists(String, boolean)
     */
    public void exists(String path, boolean watch, StatCallback cb, Object ctx) {
<span class="pc bpc" id="L1168" title="1 of 2 branches missed.">        exists(path, watch ? watchManager.defaultWatcher : null, cb, ctx);</span>
<span class="fc" id="L1169">    }</span>

    /**
     * Return the data and the stat of the node of the given path.
     * &lt;p&gt;
     * If the watch is non-null and the call is successful (no exception is
     * thrown), a watch will be left on the node with the given path. The watch
     * will be triggered by a successful operation that sets data on the node, or
     * deletes the node.
     * &lt;p&gt;
     * A KeeperException with error code KeeperException.NoNode will be thrown
     * if no node with the given path exists.
     *
     * @param path the given path
     * @param watcher explicit watcher
     * @param stat the stat of the node
     * @return the data of the node
     * @throws KeeperException If the server signals an error with a non-zero error code
     * @throws InterruptedException If the server transaction is interrupted.
     * @throws IllegalArgumentException if an invalid path is specified
     */
    public byte[] getData(final String path, Watcher watcher, Stat stat)
        throws KeeperException, InterruptedException
     {
<span class="fc" id="L1193">        final String clientPath = path;</span>
<span class="fc" id="L1194">        PathUtils.validatePath(clientPath);</span>

        // the watch contains the un-chroot path
<span class="fc" id="L1197">        WatchRegistration wcb = null;</span>
<span class="fc bfc" id="L1198" title="All 2 branches covered.">        if (watcher != null) {</span>
<span class="fc" id="L1199">            wcb = new DataWatchRegistration(watcher, clientPath);</span>
        }

<span class="fc" id="L1202">        final String serverPath = prependChroot(clientPath);</span>

<span class="fc" id="L1204">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L1205">        h.setType(ZooDefs.OpCode.getData);</span>
<span class="fc" id="L1206">        GetDataRequest request = new GetDataRequest();</span>
<span class="fc" id="L1207">        request.setPath(serverPath);</span>
<span class="fc bfc" id="L1208" title="All 2 branches covered.">        request.setWatch(watcher != null);</span>
<span class="fc" id="L1209">        GetDataResponse response = new GetDataResponse();</span>
<span class="fc" id="L1210">        ReplyHeader r = cnxn.submitRequest(h, request, response, wcb);</span>
<span class="fc bfc" id="L1211" title="All 2 branches covered.">        if (r.getErr() != 0) {</span>
<span class="fc" id="L1212">            throw KeeperException.create(KeeperException.Code.get(r.getErr()),</span>
                    clientPath);
        }
<span class="fc bfc" id="L1215" title="All 2 branches covered.">        if (stat != null) {</span>
<span class="fc" id="L1216">            DataTree.copyStat(response.getStat(), stat);</span>
        }
<span class="fc" id="L1218">        return response.getData();</span>
    }

    /**
     * Return the data and the stat of the node of the given path.
     * &lt;p&gt;
     * If the watch is true and the call is successful (no exception is
     * thrown), a watch will be left on the node with the given path. The watch
     * will be triggered by a successful operation that sets data on the node, or
     * deletes the node.
     * &lt;p&gt;
     * A KeeperException with error code KeeperException.NoNode will be thrown
     * if no node with the given path exists.
     *
     * @param path the given path
     * @param watch whether need to watch this node
     * @param stat the stat of the node
     * @return the data of the node
     * @throws KeeperException If the server signals an error with a non-zero error code
     * @throws InterruptedException If the server transaction is interrupted.
     */
    public byte[] getData(String path, boolean watch, Stat stat)
            throws KeeperException, InterruptedException {
<span class="fc bfc" id="L1241" title="All 2 branches covered.">        return getData(path, watch ? watchManager.defaultWatcher : null, stat);</span>
    }

    /**
     * The asynchronous version of getData.
     *
     * @see #getData(String, Watcher, Stat)
     */
    public void getData(final String path, Watcher watcher,
            DataCallback cb, Object ctx)
    {
<span class="fc" id="L1252">        final String clientPath = path;</span>
<span class="fc" id="L1253">        PathUtils.validatePath(clientPath);</span>

        // the watch contains the un-chroot path
<span class="fc" id="L1256">        WatchRegistration wcb = null;</span>
<span class="pc bpc" id="L1257" title="1 of 2 branches missed.">        if (watcher != null) {</span>
<span class="nc" id="L1258">            wcb = new DataWatchRegistration(watcher, clientPath);</span>
        }

<span class="fc" id="L1261">        final String serverPath = prependChroot(clientPath);</span>

<span class="fc" id="L1263">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L1264">        h.setType(ZooDefs.OpCode.getData);</span>
<span class="fc" id="L1265">        GetDataRequest request = new GetDataRequest();</span>
<span class="fc" id="L1266">        request.setPath(serverPath);</span>
<span class="pc bpc" id="L1267" title="1 of 2 branches missed.">        request.setWatch(watcher != null);</span>
<span class="fc" id="L1268">        GetDataResponse response = new GetDataResponse();</span>
<span class="fc" id="L1269">        cnxn.queuePacket(h, new ReplyHeader(), request, response, cb,</span>
                clientPath, serverPath, ctx, wcb);
<span class="fc" id="L1271">    }</span>

    /**
     * The asynchronous version of getData.
     *
     * @see #getData(String, boolean, Stat)
     */
    public void getData(String path, boolean watch, DataCallback cb, Object ctx) {
<span class="pc bpc" id="L1279" title="1 of 2 branches missed.">        getData(path, watch ? watchManager.defaultWatcher : null, cb, ctx);</span>
<span class="fc" id="L1280">    }</span>

    /**
     * Set the data for the node of the given path if such a node exists and the
     * given version matches the version of the node (if the given version is
     * -1, it matches any node's versions). Return the stat of the node.
     * &lt;p&gt;
     * This operation, if successful, will trigger all the watches on the node
     * of the given path left by getData calls.
     * &lt;p&gt;
     * A KeeperException with error code KeeperException.NoNode will be thrown
     * if no node with the given path exists.
     * &lt;p&gt;
     * A KeeperException with error code KeeperException.BadVersion will be
     * thrown if the given version does not match the node's version.
     * &lt;p&gt;
     * The maximum allowable size of the data array is 1 MB (1,048,576 bytes).
     * Arrays larger than this will cause a KeeperException to be thrown.
     *
     * @param path
     *                the path of the node
     * @param data
     *                the data to set
     * @param version
     *                the expected matching version
     * @return the state of the node
     * @throws InterruptedException If the server transaction is interrupted.
     * @throws KeeperException If the server signals an error with a non-zero error code.
     * @throws IllegalArgumentException if an invalid path is specified
     */
    public Stat setData(final String path, byte data[], int version)
        throws KeeperException, InterruptedException
    {
<span class="fc" id="L1313">        final String clientPath = path;</span>
<span class="fc" id="L1314">        PathUtils.validatePath(clientPath);</span>

<span class="fc" id="L1316">        final String serverPath = prependChroot(clientPath);</span>

<span class="fc" id="L1318">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L1319">        h.setType(ZooDefs.OpCode.setData);</span>
<span class="fc" id="L1320">        SetDataRequest request = new SetDataRequest();</span>
<span class="fc" id="L1321">        request.setPath(serverPath);</span>
<span class="fc" id="L1322">        request.setData(data);</span>
<span class="fc" id="L1323">        request.setVersion(version);</span>
<span class="fc" id="L1324">        SetDataResponse response = new SetDataResponse();</span>
<span class="fc" id="L1325">        ReplyHeader r = cnxn.submitRequest(h, request, response, null);</span>
<span class="fc bfc" id="L1326" title="All 2 branches covered.">        if (r.getErr() != 0) {</span>
<span class="fc" id="L1327">            throw KeeperException.create(KeeperException.Code.get(r.getErr()),</span>
                    clientPath);
        }
<span class="fc" id="L1330">        return response.getStat();</span>
    }

    /**
     * The asynchronous version of setData.
     *
     * @see #setData(String, byte[], int)
     */
    public void setData(final String path, byte data[], int version,
            StatCallback cb, Object ctx)
    {
<span class="fc" id="L1341">        final String clientPath = path;</span>
<span class="fc" id="L1342">        PathUtils.validatePath(clientPath);</span>

<span class="fc" id="L1344">        final String serverPath = prependChroot(clientPath);</span>

<span class="fc" id="L1346">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L1347">        h.setType(ZooDefs.OpCode.setData);</span>
<span class="fc" id="L1348">        SetDataRequest request = new SetDataRequest();</span>
<span class="fc" id="L1349">        request.setPath(serverPath);</span>
<span class="fc" id="L1350">        request.setData(data);</span>
<span class="fc" id="L1351">        request.setVersion(version);</span>
<span class="fc" id="L1352">        SetDataResponse response = new SetDataResponse();</span>
<span class="fc" id="L1353">        cnxn.queuePacket(h, new ReplyHeader(), request, response, cb,</span>
                clientPath, serverPath, ctx, null);
<span class="fc" id="L1355">    }</span>

    /**
     * Return the ACL and stat of the node of the given path.
     * &lt;p&gt;
     * A KeeperException with error code KeeperException.NoNode will be thrown
     * if no node with the given path exists.
     *
     * @param path
     *                the given path for the node
     * @param stat
     *                the stat of the node will be copied to this parameter if
     *                not null.
     * @return the ACL array of the given node.
     * @throws InterruptedException If the server transaction is interrupted.
     * @throws KeeperException If the server signals an error with a non-zero error code.
     * @throws IllegalArgumentException if an invalid path is specified
     */
    public List&lt;ACL&gt; getACL(final String path, Stat stat)
        throws KeeperException, InterruptedException
    {
<span class="fc" id="L1376">        final String clientPath = path;</span>
<span class="fc" id="L1377">        PathUtils.validatePath(clientPath);</span>

<span class="fc" id="L1379">        final String serverPath = prependChroot(clientPath);</span>

<span class="fc" id="L1381">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L1382">        h.setType(ZooDefs.OpCode.getACL);</span>
<span class="fc" id="L1383">        GetACLRequest request = new GetACLRequest();</span>
<span class="fc" id="L1384">        request.setPath(serverPath);</span>
<span class="fc" id="L1385">        GetACLResponse response = new GetACLResponse();</span>
<span class="fc" id="L1386">        ReplyHeader r = cnxn.submitRequest(h, request, response, null);</span>
<span class="pc bpc" id="L1387" title="1 of 2 branches missed.">        if (r.getErr() != 0) {</span>
<span class="nc" id="L1388">            throw KeeperException.create(KeeperException.Code.get(r.getErr()),</span>
                    clientPath);
        }
<span class="fc bfc" id="L1391" title="All 2 branches covered.">        if (stat != null) {</span>
<span class="fc" id="L1392">            DataTree.copyStat(response.getStat(), stat);</span>
        }
<span class="fc" id="L1394">        return response.getAcl();</span>
    }

    /**
     * The asynchronous version of getACL.
     *
     * @see #getACL(String, Stat)
     */
    public void getACL(final String path, Stat stat, ACLCallback cb,
            Object ctx)
    {
<span class="fc" id="L1405">        final String clientPath = path;</span>
<span class="fc" id="L1406">        PathUtils.validatePath(clientPath);</span>

<span class="fc" id="L1408">        final String serverPath = prependChroot(clientPath);</span>

<span class="fc" id="L1410">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L1411">        h.setType(ZooDefs.OpCode.getACL);</span>
<span class="fc" id="L1412">        GetACLRequest request = new GetACLRequest();</span>
<span class="fc" id="L1413">        request.setPath(serverPath);</span>
<span class="fc" id="L1414">        GetACLResponse response = new GetACLResponse();</span>
<span class="fc" id="L1415">        cnxn.queuePacket(h, new ReplyHeader(), request, response, cb,</span>
                clientPath, serverPath, ctx, null);
<span class="fc" id="L1417">    }</span>

    /**
     * Set the ACL for the node of the given path if such a node exists and the
     * given version matches the version of the node. Return the stat of the
     * node.
     * &lt;p&gt;
     * A KeeperException with error code KeeperException.NoNode will be thrown
     * if no node with the given path exists.
     * &lt;p&gt;
     * A KeeperException with error code KeeperException.BadVersion will be
     * thrown if the given version does not match the node's version.
     *
     * @param path
     * @param acl
     * @param version
     * @return the stat of the node.
     * @throws InterruptedException If the server transaction is interrupted.
     * @throws KeeperException If the server signals an error with a non-zero error code.
     * @throws org.apache.zookeeper.KeeperException.InvalidACLException If the acl is invalide.
     * @throws IllegalArgumentException if an invalid path is specified
     */
    public Stat setACL(final String path, List&lt;ACL&gt; acl, int version)
        throws KeeperException, InterruptedException
    {
<span class="fc" id="L1442">        final String clientPath = path;</span>
<span class="fc" id="L1443">        PathUtils.validatePath(clientPath);</span>

<span class="fc" id="L1445">        final String serverPath = prependChroot(clientPath);</span>

<span class="fc" id="L1447">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L1448">        h.setType(ZooDefs.OpCode.setACL);</span>
<span class="fc" id="L1449">        SetACLRequest request = new SetACLRequest();</span>
<span class="fc" id="L1450">        request.setPath(serverPath);</span>
<span class="pc bpc" id="L1451" title="2 of 4 branches missed.">        if (acl != null &amp;&amp; acl.size() == 0) {</span>
<span class="nc" id="L1452">            throw new KeeperException.InvalidACLException(clientPath);</span>
        }
<span class="fc" id="L1454">        request.setAcl(acl);</span>
<span class="fc" id="L1455">        request.setVersion(version);</span>
<span class="fc" id="L1456">        SetACLResponse response = new SetACLResponse();</span>
<span class="fc" id="L1457">        ReplyHeader r = cnxn.submitRequest(h, request, response, null);</span>
<span class="pc bpc" id="L1458" title="1 of 2 branches missed.">        if (r.getErr() != 0) {</span>
<span class="nc" id="L1459">            throw KeeperException.create(KeeperException.Code.get(r.getErr()),</span>
                    clientPath);
        }
<span class="fc" id="L1462">        return response.getStat();</span>
    }

    /**
     * The asynchronous version of setACL.
     *
     * @see #setACL(String, List, int)
     */
    public void setACL(final String path, List&lt;ACL&gt; acl, int version,
            StatCallback cb, Object ctx)
    {
<span class="fc" id="L1473">        final String clientPath = path;</span>
<span class="fc" id="L1474">        PathUtils.validatePath(clientPath);</span>

<span class="fc" id="L1476">        final String serverPath = prependChroot(clientPath);</span>

<span class="fc" id="L1478">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L1479">        h.setType(ZooDefs.OpCode.setACL);</span>
<span class="fc" id="L1480">        SetACLRequest request = new SetACLRequest();</span>
<span class="fc" id="L1481">        request.setPath(serverPath);</span>
<span class="fc" id="L1482">        request.setAcl(acl);</span>
<span class="fc" id="L1483">        request.setVersion(version);</span>
<span class="fc" id="L1484">        SetACLResponse response = new SetACLResponse();</span>
<span class="fc" id="L1485">        cnxn.queuePacket(h, new ReplyHeader(), request, response, cb,</span>
                clientPath, serverPath, ctx, null);
<span class="fc" id="L1487">    }</span>

    /**
     * Return the list of the children of the node of the given path.
     * &lt;p&gt;
     * If the watch is non-null and the call is successful (no exception is thrown),
     * a watch will be left on the node with the given path. The watch willbe
     * triggered by a successful operation that deletes the node of the given
     * path or creates/delete a child under the node.
     * &lt;p&gt;
     * The list of children returned is not sorted and no guarantee is provided
     * as to its natural or lexical order.
     * &lt;p&gt;
     * A KeeperException with error code KeeperException.NoNode will be thrown
     * if no node with the given path exists.
     *
     * @param path
     * @param watcher explicit watcher
     * @return an unordered array of children of the node with the given path
     * @throws InterruptedException If the server transaction is interrupted.
     * @throws KeeperException If the server signals an error with a non-zero error code.
     * @throws IllegalArgumentException if an invalid path is specified
     */
    public List&lt;String&gt; getChildren(final String path, Watcher watcher)
        throws KeeperException, InterruptedException
    {
<span class="fc" id="L1513">        final String clientPath = path;</span>
<span class="fc" id="L1514">        PathUtils.validatePath(clientPath);</span>

        // the watch contains the un-chroot path
<span class="fc" id="L1517">        WatchRegistration wcb = null;</span>
<span class="fc bfc" id="L1518" title="All 2 branches covered.">        if (watcher != null) {</span>
<span class="fc" id="L1519">            wcb = new ChildWatchRegistration(watcher, clientPath);</span>
        }

<span class="fc" id="L1522">        final String serverPath = prependChroot(clientPath);</span>

<span class="fc" id="L1524">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L1525">        h.setType(ZooDefs.OpCode.getChildren);</span>
<span class="fc" id="L1526">        GetChildrenRequest request = new GetChildrenRequest();</span>
<span class="fc" id="L1527">        request.setPath(serverPath);</span>
<span class="fc bfc" id="L1528" title="All 2 branches covered.">        request.setWatch(watcher != null);</span>
<span class="fc" id="L1529">        GetChildrenResponse response = new GetChildrenResponse();</span>
<span class="fc" id="L1530">        ReplyHeader r = cnxn.submitRequest(h, request, response, wcb);</span>
<span class="fc bfc" id="L1531" title="All 2 branches covered.">        if (r.getErr() != 0) {</span>
<span class="fc" id="L1532">            throw KeeperException.create(KeeperException.Code.get(r.getErr()),</span>
                    clientPath);
        }
<span class="fc" id="L1535">        return response.getChildren();</span>
    }

    /**
     * Return the list of the children of the node of the given path.
     * &lt;p&gt;
     * If the watch is true and the call is successful (no exception is thrown),
     * a watch will be left on the node with the given path. The watch willbe
     * triggered by a successful operation that deletes the node of the given
     * path or creates/delete a child under the node.
     * &lt;p&gt;
     * The list of children returned is not sorted and no guarantee is provided
     * as to its natural or lexical order.
     * &lt;p&gt;
     * A KeeperException with error code KeeperException.NoNode will be thrown
     * if no node with the given path exists.
     *
     * @param path
     * @param watch
     * @return an unordered array of children of the node with the given path
     * @throws InterruptedException If the server transaction is interrupted.
     * @throws KeeperException If the server signals an error with a non-zero error code.
     */
    public List&lt;String&gt; getChildren(String path, boolean watch)
            throws KeeperException, InterruptedException {
<span class="fc bfc" id="L1560" title="All 2 branches covered.">        return getChildren(path, watch ? watchManager.defaultWatcher : null);</span>
    }

    /**
     * The asynchronous version of getChildren.
     *
     * @see #getChildren(String, Watcher)
     */
    public void getChildren(final String path, Watcher watcher,
            ChildrenCallback cb, Object ctx)
    {
<span class="fc" id="L1571">        final String clientPath = path;</span>
<span class="fc" id="L1572">        PathUtils.validatePath(clientPath);</span>

        // the watch contains the un-chroot path
<span class="fc" id="L1575">        WatchRegistration wcb = null;</span>
<span class="fc bfc" id="L1576" title="All 2 branches covered.">        if (watcher != null) {</span>
<span class="fc" id="L1577">            wcb = new ChildWatchRegistration(watcher, clientPath);</span>
        }

<span class="fc" id="L1580">        final String serverPath = prependChroot(clientPath);</span>

<span class="fc" id="L1582">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L1583">        h.setType(ZooDefs.OpCode.getChildren);</span>
<span class="fc" id="L1584">        GetChildrenRequest request = new GetChildrenRequest();</span>
<span class="fc" id="L1585">        request.setPath(serverPath);</span>
<span class="fc bfc" id="L1586" title="All 2 branches covered.">        request.setWatch(watcher != null);</span>
<span class="fc" id="L1587">        GetChildrenResponse response = new GetChildrenResponse();</span>
<span class="fc" id="L1588">        cnxn.queuePacket(h, new ReplyHeader(), request, response, cb,</span>
                clientPath, serverPath, ctx, wcb);
<span class="fc" id="L1590">    }</span>

    /**
     * The asynchronous version of getChildren.
     *
     * @see #getChildren(String, boolean)
     */
    public void getChildren(String path, boolean watch, ChildrenCallback cb,
            Object ctx)
    {
<span class="pc bpc" id="L1600" title="1 of 2 branches missed.">        getChildren(path, watch ? watchManager.defaultWatcher : null, cb, ctx);</span>
<span class="fc" id="L1601">    }</span>

    /**
     * For the given znode path return the stat and children list.
     * &lt;p&gt;
     * If the watch is non-null and the call is successful (no exception is thrown),
     * a watch will be left on the node with the given path. The watch willbe
     * triggered by a successful operation that deletes the node of the given
     * path or creates/delete a child under the node.
     * &lt;p&gt;
     * The list of children returned is not sorted and no guarantee is provided
     * as to its natural or lexical order.
     * &lt;p&gt;
     * A KeeperException with error code KeeperException.NoNode will be thrown
     * if no node with the given path exists.
     *
     * @since 3.3.0
     * 
     * @param path
     * @param watcher explicit watcher
     * @param stat stat of the znode designated by path
     * @return an unordered array of children of the node with the given path
     * @throws InterruptedException If the server transaction is interrupted.
     * @throws KeeperException If the server signals an error with a non-zero error code.
     * @throws IllegalArgumentException if an invalid path is specified
     */
    public List&lt;String&gt; getChildren(final String path, Watcher watcher,
            Stat stat)
        throws KeeperException, InterruptedException
    {
<span class="fc" id="L1631">        final String clientPath = path;</span>
<span class="fc" id="L1632">        PathUtils.validatePath(clientPath);</span>

        // the watch contains the un-chroot path
<span class="fc" id="L1635">        WatchRegistration wcb = null;</span>
<span class="pc bpc" id="L1636" title="1 of 2 branches missed.">        if (watcher != null) {</span>
<span class="nc" id="L1637">            wcb = new ChildWatchRegistration(watcher, clientPath);</span>
        }

<span class="fc" id="L1640">        final String serverPath = prependChroot(clientPath);</span>

<span class="fc" id="L1642">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L1643">        h.setType(ZooDefs.OpCode.getChildren2);</span>
<span class="fc" id="L1644">        GetChildren2Request request = new GetChildren2Request();</span>
<span class="fc" id="L1645">        request.setPath(serverPath);</span>
<span class="pc bpc" id="L1646" title="1 of 2 branches missed.">        request.setWatch(watcher != null);</span>
<span class="fc" id="L1647">        GetChildren2Response response = new GetChildren2Response();</span>
<span class="fc" id="L1648">        ReplyHeader r = cnxn.submitRequest(h, request, response, wcb);</span>
<span class="pc bpc" id="L1649" title="1 of 2 branches missed.">        if (r.getErr() != 0) {</span>
<span class="nc" id="L1650">            throw KeeperException.create(KeeperException.Code.get(r.getErr()),</span>
                    clientPath);
        }
<span class="fc bfc" id="L1653" title="All 2 branches covered.">        if (stat != null) {</span>
<span class="fc" id="L1654">            DataTree.copyStat(response.getStat(), stat);</span>
        }
<span class="fc" id="L1656">        return response.getChildren();</span>
    }

    /**
     * For the given znode path return the stat and children list.
     * &lt;p&gt;
     * If the watch is true and the call is successful (no exception is thrown),
     * a watch will be left on the node with the given path. The watch willbe
     * triggered by a successful operation that deletes the node of the given
     * path or creates/delete a child under the node.
     * &lt;p&gt;
     * The list of children returned is not sorted and no guarantee is provided
     * as to its natural or lexical order.
     * &lt;p&gt;
     * A KeeperException with error code KeeperException.NoNode will be thrown
     * if no node with the given path exists.
     *
     * @since 3.3.0
     * 
     * @param path
     * @param watch
     * @param stat stat of the znode designated by path
     * @return an unordered array of children of the node with the given path
     * @throws InterruptedException If the server transaction is interrupted.
     * @throws KeeperException If the server signals an error with a non-zero
     *  error code.
     */
    public List&lt;String&gt; getChildren(String path, boolean watch, Stat stat)
            throws KeeperException, InterruptedException {
<span class="pc bpc" id="L1685" title="1 of 2 branches missed.">        return getChildren(path, watch ? watchManager.defaultWatcher : null,</span>
                stat);
    }

    /**
     * The asynchronous version of getChildren.
     *
     * @since 3.3.0
     * 
     * @see #getChildren(String, Watcher, Stat)
     */
    public void getChildren(final String path, Watcher watcher,
            Children2Callback cb, Object ctx)
    {
<span class="fc" id="L1699">        final String clientPath = path;</span>
<span class="fc" id="L1700">        PathUtils.validatePath(clientPath);</span>

        // the watch contains the un-chroot path
<span class="fc" id="L1703">        WatchRegistration wcb = null;</span>
<span class="fc bfc" id="L1704" title="All 2 branches covered.">        if (watcher != null) {</span>
<span class="fc" id="L1705">            wcb = new ChildWatchRegistration(watcher, clientPath);</span>
        }

<span class="fc" id="L1708">        final String serverPath = prependChroot(clientPath);</span>

<span class="fc" id="L1710">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L1711">        h.setType(ZooDefs.OpCode.getChildren2);</span>
<span class="fc" id="L1712">        GetChildren2Request request = new GetChildren2Request();</span>
<span class="fc" id="L1713">        request.setPath(serverPath);</span>
<span class="fc bfc" id="L1714" title="All 2 branches covered.">        request.setWatch(watcher != null);</span>
<span class="fc" id="L1715">        GetChildren2Response response = new GetChildren2Response();</span>
<span class="fc" id="L1716">        cnxn.queuePacket(h, new ReplyHeader(), request, response, cb,</span>
                clientPath, serverPath, ctx, wcb);
<span class="fc" id="L1718">    }</span>

    /**
     * The asynchronous version of getChildren.
     *
     * @since 3.3.0
     * 
     * @see #getChildren(String, boolean, Stat)
     */
    public void getChildren(String path, boolean watch, Children2Callback cb,
            Object ctx)
    {
<span class="pc bpc" id="L1730" title="1 of 2 branches missed.">        getChildren(path, watch ? watchManager.defaultWatcher : null, cb, ctx);</span>
<span class="fc" id="L1731">    }</span>

    /**
     * Asynchronous sync. Flushes channel between process and leader.
     * @param path
     * @param cb a handler for the callback
     * @param ctx context to be provided to the callback
     * @throws IllegalArgumentException if an invalid path is specified
     */
    public void sync(final String path, VoidCallback cb, Object ctx){
<span class="fc" id="L1741">        final String clientPath = path;</span>
<span class="fc" id="L1742">        PathUtils.validatePath(clientPath);</span>

<span class="fc" id="L1744">        final String serverPath = prependChroot(clientPath);</span>

<span class="fc" id="L1746">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L1747">        h.setType(ZooDefs.OpCode.sync);</span>
<span class="fc" id="L1748">        SyncRequest request = new SyncRequest();</span>
<span class="fc" id="L1749">        SyncResponse response = new SyncResponse();</span>
<span class="fc" id="L1750">        request.setPath(serverPath);</span>
<span class="fc" id="L1751">        cnxn.queuePacket(h, new ReplyHeader(), request, response, cb,</span>
                clientPath, serverPath, ctx, null);
<span class="fc" id="L1753">    }</span>

    public States getState() {
<span class="fc" id="L1756">        return cnxn.getState();</span>
    }

    /**
     * String representation of this ZooKeeper client. Suitable for things
     * like logging.
     * 
     * Do NOT count on the format of this string, it may change without
     * warning.
     * 
     * @since 3.3.0
     */
    @Override
    public String toString() {
<span class="fc" id="L1770">        States state = getState();</span>
<span class="fc" id="L1771">        return (&quot;State:&quot; + state.toString()</span>
<span class="fc bfc" id="L1772" title="All 2 branches covered.">                + (state.isConnected() ?</span>
<span class="fc" id="L1773">                        &quot; Timeout:&quot; + getSessionTimeout() + &quot; &quot; :</span>
                        &quot; &quot;)
                + cnxn);
    }

    /*
     * Methods to aid in testing follow.
     * 
     * THESE METHODS ARE EXPECTED TO BE USED FOR TESTING ONLY!!!
     */

    /**
     * Wait up to wait milliseconds for the underlying threads to shutdown.
     * THIS METHOD IS EXPECTED TO BE USED FOR TESTING ONLY!!!
     * 
     * @since 3.3.0
     * 
     * @param wait max wait in milliseconds
     * @return true iff all threads are shutdown, otw false
     */
    protected boolean testableWaitForShutdown(int wait)
        throws InterruptedException
    {
<span class="fc" id="L1796">        cnxn.sendThread.join(wait);</span>
<span class="pc bpc" id="L1797" title="1 of 2 branches missed.">        if (cnxn.sendThread.isAlive()) return false;</span>
<span class="fc" id="L1798">        cnxn.eventThread.join(wait);</span>
<span class="pc bpc" id="L1799" title="1 of 2 branches missed.">        if (cnxn.eventThread.isAlive()) return false;</span>
<span class="fc" id="L1800">        return true;</span>
    }

    /**
     * Returns the address to which the socket is connected. Useful for testing
     * against an ensemble - test client may need to know which server
     * to shutdown if interested in verifying that the code handles
     * disconnection/reconnection correctly.
     * THIS METHOD IS EXPECTED TO BE USED FOR TESTING ONLY!!!
     *
     * @since 3.3.0
     * 
     * @return ip address of the remote side of the connection or null if
     *         not connected
     */
    protected SocketAddress testableRemoteSocketAddress() {
<span class="fc" id="L1816">        return cnxn.sendThread.getClientCnxnSocket().getRemoteSocketAddress();</span>
    }

    /** 
     * Returns the local address to which the socket is bound.
     * THIS METHOD IS EXPECTED TO BE USED FOR TESTING ONLY!!!
     *
     * @since 3.3.0
     * 
     * @return ip address of the remote side of the connection or null if
     *         not connected
     */
    protected SocketAddress testableLocalSocketAddress() {
<span class="fc" id="L1829">        return cnxn.sendThread.getClientCnxnSocket().getLocalSocketAddress();</span>
    }

    private static ClientCnxnSocket getClientCnxnSocket() throws IOException {
<span class="fc" id="L1833">        String clientCnxnSocketName = System</span>
<span class="fc" id="L1834">                .getProperty(ZOOKEEPER_CLIENT_CNXN_SOCKET);</span>
<span class="pc bpc" id="L1835" title="1 of 2 branches missed.">        if (clientCnxnSocketName == null) {</span>
<span class="fc" id="L1836">            clientCnxnSocketName = ClientCnxnSocketNIO.class.getName();</span>
        }
        try {
<span class="fc" id="L1839">            return (ClientCnxnSocket) Class.forName(clientCnxnSocketName)</span>
<span class="fc" id="L1840">                    .newInstance();</span>
<span class="nc" id="L1841">        } catch (Exception e) {</span>
<span class="nc" id="L1842">            IOException ioe = new IOException(&quot;Couldn't instantiate &quot;</span>
                    + clientCnxnSocketName);
<span class="nc" id="L1844">            ioe.initCause(e);</span>
<span class="nc" id="L1845">            throw ioe;</span>
        }
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>